"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertValidationErrors = convertValidationErrors;
exports.validateWithTypedValidators = validateWithTypedValidators;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _sequelizeValidateSubfields = require("sequelize-validate-subfields");
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function checkPath(path) {
  var _iterator = _createForOfIteratorHelper(path),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var elem = _step.value;
      if (typeof elem !== 'string' && (0, _typeof2["default"])(elem) !== 'symbol') {
        throw new Error("invalid error path element: ".concat((0, _typeof2["default"])(elem), ", ").concat(String(elem)));
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return path;
}
function convertValidationErrors(validation) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var _iterator2, _step2, error;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _iterator2 = _createForOfIteratorHelper(validation.errors);
          _context.prev = 1;
          _iterator2.s();
        case 3:
          if ((_step2 = _iterator2.n()).done) {
            _context.next = 14;
            break;
          }
          error = _step2.value;
          if (!(options.reduxFormStyle && error.expectedTypeAtPath.acceptsSomeCompositeTypes)) {
            _context.next = 10;
            break;
          }
          _context.next = 8;
          return {
            path: [].concat((0, _toConsumableArray2["default"])(checkPath(error.path)), ['_error']),
            message: error.messageAtPath()
          };
        case 8:
          _context.next = 12;
          break;
        case 10:
          _context.next = 12;
          return {
            path: checkPath(error.path),
            message: error.messageAtPath()
          };
        case 12:
          _context.next = 3;
          break;
        case 14:
          _context.next = 19;
          break;
        case 16:
          _context.prev = 16;
          _context.t0 = _context["catch"](1);
          _iterator2.e(_context.t0);
        case 19:
          _context.prev = 19;
          _iterator2.f();
          return _context.finish(19);
        case 22:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 16, 19, 22]]);
  })();
}
function validateWithTypedValidators(type) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return (0, _sequelizeValidateSubfields.validateSubfields)( /*#__PURE__*/_regenerator["default"].mark(function _callee2(value) {
    var validation;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          validation = typeof type === 'function' ? type(value) : type.validate(value, undefined, []);
          if (!validation) {
            _context2.next = 3;
            break;
          }
          return _context2.delegateYield(convertValidationErrors(validation, options), "t0", 3);
        case 3:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
}